﻿using System.Collections.Generic;
using System.ServiceModel;
using System.Linq;
using System.ServiceModel.Activation;
using System.Net;
using System.ServiceModel.Web;

namespace jQueryMVC {
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "MovieService" in code,
    //       svc and config file together.
    [ServiceBehavior (InstanceContextMode = InstanceContextMode.Single, // singleton
                      ConcurrencyMode = ConcurrencyMode.Multiple,       // our class implementation MUST be thread-safe
                      IncludeExceptionDetailInFaults = true)]
    [AspNetCompatibilityRequirements (RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class MovieService : IMovieService {
        private Movies repository = new Movies () {
            new Movie() {Id=100, Name="E.T.", Director="Steven Spielberg", ReleaseDate="1982"},
            new Movie() {Id=200, Name="The Green Mile", Director="Frank Darabont", ReleaseDate="1999"}
        };
        private Dictionary<int, Movie> repositoryDictionary = new Dictionary<int,Movie>();
        public MovieService () {
            foreach (Movie movie in repository) {
                if (!repositoryDictionary.ContainsKey (movie.Id))
                    repositoryDictionary.Add (movie.Id, movie);
            }
        }

        public Movies GetMovies () {
            return (Movies)repository;
        }

        public void SetTestcluster (string idStr, Movie item) {
            int id;
            if (!int.TryParse (idStr, out id)) {
                //throw new WebFaultException<string> (
                //    string.Format ("There is no Movie with Id='{0}'.", idStr),
                //    HttpStatusCode.NotFound);
                WebOperationContext.Current.OutgoingResponse.StatusCode = HttpStatusCode.NotFound;
            }
            Movie oldItem = (from m in repository
                          where m.Id == id
                          select m).SingleOrDefault();;
            if (oldItem == null) {
                //throw new WebFaultException<string> (
                //    string.Format ("There is no Movie with Id='{0}'.", idStr),
                //    HttpStatusCode.NotFound);
                WebOperationContext.Current.OutgoingResponse.StatusCode = HttpStatusCode.NotFound;
            }
            // change all editable fields
            oldItem.Name = item.Name;
            oldItem.Director = item.Director;
            oldItem.ReleaseDate = item.ReleaseDate;
        }
    }
}
